package com.diagbot.util;

import com.diagbot.facade.data.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

@Slf4j
@Component
/**
 * 启动时执行缓存，将字段名和注释存储到MAP类型的缓存中
 */
public class ColumnCacheUtil implements ApplicationRunner {

    @Override
    public void run(ApplicationArguments args) throws Exception {
        try {
            aStrBloodResultFacade.getColumnZhAndCh();
            aStrBloodTransfusionFacade.getColumnZhAndCh();
            aStrAdmissionNoteFacade.getColumnZhAndCh();//入院记录
            aStrFirstRecordFacade.getColumnZhAndCh();
            aStrPeriodConclusionFacade.getColumnZhAndCh();
            aStrTransferInNoteFacade.getColumnZhAndCh();
            aStrTransferOutNoteFacade.getColumnZhAndCh();
            aStrIllSeriouslFacade.getColumnZhAndCh();
            aStrIllCriticallyFacade.getColumnZhAndCh();
            aStrDifficultCaseFacade.getColumnZhAndCh();
            aStrDeathNoteFacade.getColumnZhAndCh();
            aStrDeathDiscussionFacade.getColumnZhAndCh();
            aStrWardRecordFacade.getColumnZhAndCh();
            aStrOperativeFirstRecord.getColumnZhAndCh();
            aStrPreoperativeDiscussionFacade.getColumnZhAndCh();
            aStrOperativeNoteFacade.getColumnZhAndCh();
            aStrRescueNoteFacade.getColumnZhAndCh();
            aStrCrisisNoteFacade.getColumnZhAndCh();
            aStrLeaveHospitalFacade.getColumnZhAndCh();
            aStrConsultationApplyFacade.getColumnZhAndCh();
            aStrConsultationResultFacade.getColumnZhAndCh();
            aStrConsultationNoteFacade.getColumnZhAndCh();
            aStrConsultationRecordFacade.getColumnZhAndCh();


            log.info("列名和注释缓存初始化完成！");
        }catch (Exception e){
            log.error(e.getMessage(),e);
        }
    }
    @Autowired
    private AStrAdmissionNoteFacade aStrAdmissionNoteFacade;
    @Autowired
    private AStrFirstRecordFacade aStrFirstRecordFacade;
    @Autowired
    private AStrPeriodConclusionFacade aStrPeriodConclusionFacade;
    @Autowired
    private AStrBloodResultFacade aStrBloodResultFacade;
    @Autowired
    private AStrBloodTransfusionFacade aStrBloodTransfusionFacade;
    @Autowired
    private AStrTransferInNoteFacade aStrTransferInNoteFacade;
    @Autowired
    private AStrTransferOutNoteFacade aStrTransferOutNoteFacade;
    @Autowired
    private AStrIllSeriouslFacade aStrIllSeriouslFacade;
    @Autowired
    private AStrIllCriticallyFacade aStrIllCriticallyFacade;
    @Autowired
    private AStrDifficultCaseFacade aStrDifficultCaseFacade;
    @Autowired
    private AStrDeathNoteFacade aStrDeathNoteFacade;
    @Autowired
    private AStrDeathDiscussionFacade aStrDeathDiscussionFacade;
    @Autowired
    private AStrWardRecordFacade aStrWardRecordFacade;
    @Autowired
    private AStrOperativeFirstRecord aStrOperativeFirstRecord;
    @Autowired
    private AStrPreoperativeDiscussionFacade aStrPreoperativeDiscussionFacade;
    @Autowired
    private AStrOperativeNoteFacade aStrOperativeNoteFacade;
    @Autowired
    private AStrRescueNoteFacade aStrRescueNoteFacade;
    @Autowired
    private AStrCrisisNoteFacade aStrCrisisNoteFacade;
    @Autowired
    private AStrLeaveHospitalFacade aStrLeaveHospitalFacade;
    @Autowired
    private AStrConsultationApplyFacade aStrConsultationApplyFacade;
    @Autowired
    private AStrConsultationResultFacade aStrConsultationResultFacade;
    @Autowired
    private AStrConsultationNoteFacade aStrConsultationNoteFacade;
    @Autowired
    private AStrConsultationRecordFacade aStrConsultationRecordFacade;
}
